classification
Title: test_read_pty_output() hangs on FreeBSD 7.2 buildbot
Type: Stage:
Components: Versions: Python 3.4
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: gvanrossum, python-dev, skrah, vstinner
Priority: normal Keywords: patch

Created on 2014-02-03 01:29 by vstinner, last changed 2014-03-17 06:30 by python-dev. This issue is now closed.

Files
File name Uploaded Description Edit
skip_read_pty_freebsd72.patch vstinner, 2014-02-11 16:46 review
Messages (6)
msg210072 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2014-02-03 01:29
http://buildbot.python.org/all/builders/x86%20FreeBSD%207.2%203.x/builds/4969/steps/test/logs/stdio
---
[298/389/1] test_asyncio
Timeout (1:00:00)!
Current thread 0x28401040 (most recent call first):
  File "/usr/home/db3l/buildarea/3.x.bolen-freebsd7/build/Lib/asyncio/base_events.py", line 208 in time
  File "/usr/home/db3l/buildarea/3.x.bolen-freebsd7/build/Lib/asyncio/base_events.py", line 641 in _run_once
  File "/usr/home/db3l/buildarea/3.x.bolen-freebsd7/build/Lib/asyncio/base_events.py", line 154 in run_forever
  File "/usr/home/db3l/buildarea/3.x.bolen-freebsd7/build/Lib/asyncio/base_events.py", line 173 in run_until_complete
  File "/usr/home/db3l/buildarea/3.x.bolen-freebsd7/build/Lib/asyncio/test_utils.py", line 44 in run_briefly
  File "/usr/home/db3l/buildarea/3.x.bolen-freebsd7/build/Lib/asyncio/test_utils.py", line 59 in run_until
  File "/usr/home/db3l/buildarea/3.x.bolen-freebsd7/build/Lib/test/test_asyncio/test_events.py", line 979 in test_read_pty_output
...
---

FYI The test is now skipped on Mac OS X older than 10.6, the test on the kqueue selector is skipped on Mac OS X older than 10.9: issue #20472.
msg210074 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2014-02-03 01:36
I guess this is not a total surprise given that OS X derives in some way from BSD...

I wonder if we just need to make a matrix of which OS versions and which syscalls can handle PTYs correctly, and either put it in the docs or perhaps even refuse to accept PTYs in add_reader/add_writer...
msg210968 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2014-02-11 16:46
> I wonder if we just need to make a matrix of which OS versions and which syscalls can handle PTYs correctly, and either put it in the docs or perhaps even refuse to accept PTYs in add_reader/add_writer...

Right now, I think that we don't have enough data to decide on which OS and OS versions such error should be raised. But I agree that it would be nice to raise an error instead of hang, crash, or just behave badly.

Until that, here is a patch to skip the test on FreeBSD < 8.0.

The test hangs on FreeBSD 7.2, test_asyncio pass on FreeBSD 9. The FreeBSD 8 buildbot is offline. test_asyncio is skipped on FreeBSD 6.4.
msg210977 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2014-02-11 17:15
LGTM
msg210987 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2014-02-11 17:41
New changeset 2ba583191550 by Victor Stinner in branch 'default':
Issue #20495: Skip test_read_pty_output() of test_asyncio on FreeBSD older than
http://hg.python.org/cpython/rev/2ba583191550
msg213811 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2014-03-17 06:30
New changeset 2cf25865fc66 by Victor Stinner in branch '3.4':
Issue #20495: Skip test_read_pty_output() of test_asyncio on FreeBSD older than
http://hg.python.org/cpython/rev/2cf25865fc66
History
Date User Action Args
2014-03-17 06:30:54python-devsetmessages: + msg213811
2014-02-11 17:42:50vstinnersetstatus: open -> closed
resolution: fixed
2014-02-11 17:41:34python-devsetnosy: + python-dev
messages: + msg210987
2014-02-11 17:15:06gvanrossumsetmessages: + msg210977
2014-02-11 16:46:44vstinnersetfiles: + skip_read_pty_freebsd72.patch
keywords: + patch
messages: + msg210968
2014-02-03 01:36:41gvanrossumsetmessages: + msg210074
2014-02-03 01:29:28vstinnercreate